#!/bin/bash

# Copyright (C) 2017-2018 Daniel Tartavel-jeannot   <contact@librepc.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


function title()
{
	echo -e "\e[1;32m$1\e[0m"
}

function info()
{
	echo -e "\e[36m$1\e[0m"
}

function warning()
{
	echo -e "\e[1;35m$1\e[0m"
}

function error()
{
	echo -e "\e[1;31m$1\e[0m"
}


BOOT_PATH=$1
ROOT_PATH=$2
FIRMWARE_TEMP="/tmp"

if [ -d $PI_BOOT_PATH ];then					# the firmware directory does not exists
	wget $FIRMWARE_DOWNLOAD_URL
	if [ $? -ne 0 ];then
		error "line $LINENO error downloading raspberry firmware at $FIRMWARE_DOWNLOAD_URL :exiting"
		exit 1
	fi
	info "extracting firmware"
	unzip -d "$FIRMWARE_TEMP" *.zip
	if [ $? -ne 0 ];then
		error "line $LINENO error unzipping $FIRMWARE_TEMP : exiting"
		exit 1
	fi
fi
diff $FIRMWARE_TEMP/extra/uname_string7 $BOOT_PATH/uname_string7
RESULT=$?
if [ $RESULT -eq 1 ]; then

	/bin/rsync -rlptDH "$FIRMWARE_TEMP/firmware-stable/boot/" "$BOOT_PATH"
	info "copying raspberry modules in /lib/modules"
	/bin/rsync -rlptDH "$FIRMWARE_TEMP/firmware-stable/modules/" "$ROOT_PATH/lib/modules/"

	info "copying raspberry files in opt"
	/bin/rsync -rlptDH "$FIRMWARE_TEMP/firmware-stable/opt/" "$ROOT_PATH/opt/"
elif [ $RESULT -eq 2 ];then
	error "line $LINEO path error: a path is false"
fi
